## libcpuid 0.8.1+repack1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

set(VERSION "0.8.1")
set(LIBCPUID_CURRENT 18)
set(LIBCPUID_AGE 1)
set(LIBCPUID_REVISION 1)
project(
  cpuid
  LANGUAGES C ASM_MASM
  VERSION ${VERSION})

# CMake modules
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

if(MSVC)
  set(LIBCPUID_SHARED OFF)
else()
  set(LIBCPUID_SHARED ON)
endif()

# Options
option(BUILD_SHARED_LIBS "Build building shared libraries" ${LIBCPUID_SHARED})
option(LIBCPUID_BUILD_DRIVERS "Enable building kernel drivers" ON)
option(LIBCPUID_ENABLE_TESTS "Enable tests targets" OFF)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_C_STANDARD 99)

# pthreads library
if(${CMAKE_SYSTEM_NAME} STREQUAL "DragonFly" OR ${CMAKE_SYSTEM_NAME} STREQUAL "NetBSD")
  find_package(Threads REQUIRED)
endif()

include(CheckSymbolExists)

# check if auxiliary vector is available
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  check_symbol_exists(getauxval "sys/auxv.h" HAVE_GETAUXVAL)
  if(HAVE_GETAUXVAL)
    add_definitions(-DHAVE_GETAUXVAL)
  endif(HAVE_GETAUXVAL)
elseif(${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
  check_symbol_exists(elf_aux_info "sys/auxv.h" HAVE_ELF_AUX_INFO)
  if(HAVE_ELF_AUX_INFO)
    add_definitions(-DHAVE_ELF_AUX_INFO)
  endif(HAVE_ELF_AUX_INFO)
endif()

# Global variables
if(UNIX)
  include(GNUInstallDirs)
  set(prefix "${CMAKE_INSTALL_PREFIX}")
  set(exec_prefix "\${prefix}")
  set(libdir "\${exec_prefix}/lib")
  set(includedir "\${prefix}/include")
  set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Wall -Wuninitialized -Wstrict-prototypes -Wformat -Wformat-security -Wunused-parameter -Wdeprecated-declarations")
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/libcpuid.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/libcpuid.pc" ESCAPE_QUOTES
                 @ONLY)
  install(FILES "${PROJECT_BINARY_DIR}/libcpuid.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
endif(UNIX)

# Include subdirectories
add_subdirectory(libcpuid)
add_subdirectory(cpuid_tool)
if(LIBCPUID_BUILD_DRIVERS)
  add_subdirectory(drivers)
endif(LIBCPUID_BUILD_DRIVERS)
if(LIBCPUID_ENABLE_TESTS)
  add_subdirectory(tests)
endif(LIBCPUID_ENABLE_TESTS)

=== cpuid_tool/CMakeLists.txt ===
add_executable(cpuid_tool cpuid_tool.c)

target_link_libraries(cpuid_tool cpuid)

if(WIN32)
  install(
    TARGETS cpuid_tool
    CONFIGURATIONS Debug
    RUNTIME DESTINATION bin/Debug)
  install(
    TARGETS cpuid_tool
    CONFIGURATIONS Release
    RUNTIME DESTINATION bin/Release)
else()
  install(TARGETS cpuid_tool DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== drivers/CMakeLists.txt ===
# Include "arm" directory only for ARM CPUs
if(("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "^armv.*") OR ("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "aarch64"))
  add_subdirectory(arm)
endif()

=== libcpuid/CMakeLists.txt ===
# Options
option(LIBCPUID_BUILD_DEPRECATED "Build support of deprecated attributes" ON)
option(LIBCPUID_ENABLE_DOCS "Enable building documentation" ON)

set(cpuid_sources
    cpuid_main.c
    recog_amd.c
    recog_arm.c
    recog_centaur.c
    recog_intel.c
    rdtsc.c
    libcpuid_util.c
    rdmsr.c
    asm-bits.c
    rdcpuid.c)

if(WIN32)
  list(APPEND cpuid_sources msrdriver.c)
endif()
if(UNIX)
  add_compile_definitions(_GNU_SOURCE)
endif(UNIX)

if("${MSVC_CXX_ARCHITECTURE_ID}" MATCHES "x64")
  list(APPEND cpuid_sources masm-x64.asm)
endif()

if(NOT LIBCPUID_BUILD_DEPRECATED)
  message(AUTHOR_WARNING "Deprecated attributes will not be available, the library will be not backward compatible")
  add_compile_definitions(LIBCPUID_DISABLE_DEPRECATED)
endif(NOT LIBCPUID_BUILD_DEPRECATED)

add_library(cpuid ${cpuid_sources})
set_property(TARGET cpuid PROPERTY WINDOWS_EXPORT_ALL_SYMBOLS ON)
target_include_directories(cpuid SYSTEM PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)

target_link_libraries(cpuid ${CMAKE_THREAD_LIBS_INIT})
target_compile_definitions(cpuid PRIVATE VERSION="${PROJECT_VERSION}")
set_target_properties(cpuid PROPERTIES VERSION "${LIBCPUID_CURRENT}.${LIBCPUID_AGE}.${LIBCPUID_REVISION}")
set_target_properties(cpuid PROPERTIES SOVERSION "${LIBCPUID_CURRENT}")
set_target_properties(cpuid PROPERTIES PUBLIC_HEADER "libcpuid.h;libcpuid_types.h;libcpuid_constants.h")

# Documentation
if(LIBCPUID_ENABLE_DOCS)
  find_package(Doxygen)
  if(DOXYGEN_FOUND)
    set(top_srcdir ${PROJECT_SOURCE_DIR})
    configure_file(Doxyfile.in Doxyfile ESCAPE_QUOTES)
    add_custom_target(
      docs ALL
      ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/
      COMMENT "Generating API documentation with Doxygen"
      VERBATIM)
    if(UNIX)
      install(
        DIRECTORY "${CMAKE_SOURCE_DIR}/docs/man/"
        DESTINATION "${CMAKE_INSTALL_MANDIR}"
        FILES_MATCHING
        PATTERN "cpu_*_t.3"
        PATTERN "libcpuid.3"
        PATTERN "cpuid_tool.3")
    endif(UNIX)
  else(DOXYGEN_FOUND)
    add_custom_target(
      docs
      echo
      "Doxygen was not installed when CMake was run. Check that Doxygen is installed and rerun `cmake .`"
      VERBATIM)
  endif(DOXYGEN_FOUND)
endif(LIBCPUID_ENABLE_DOCS)

# Configuration
set(generated_dir "${CMAKE_CURRENT_BINARY_DIR}/generated")
set(config_install_dir "lib/cmake/${PROJECT_NAME}")
set(version_config "${generated_dir}/${PROJECT_NAME}ConfigVersion.cmake")
set(project_config "${generated_dir}/${PROJECT_NAME}Config.cmake")
set(TARGETS_EXPORT_NAME "${PROJECT_NAME}Targets")
set(namespace "${PROJECT_NAME}::")

include(CMakePackageConfigHelpers)

# Configure '<PROJECT-NAME>ConfigVersion.cmake' Use: * PROJECT_VERSION
write_basic_package_version_file("${version_config}" COMPATIBILITY SameMajorVersion)

# Configure '<PROJECT-NAME>Config.cmake' Use variables: * TARGETS_EXPORT_NAME * PROJECT_NAME
configure_package_config_file("${PROJECT_SOURCE_DIR}/cmake/Config.cmake.in" "${project_config}"
                              INSTALL_DESTINATION "${config_install_dir}")

# Installation

install(
  TARGETS cpuid
  EXPORT "${TARGETS_EXPORT_NAME}"
  LIBRARY DESTINATION "lib"
  ARCHIVE DESTINATION "lib"
  RUNTIME DESTINATION "bin"
  INCLUDES DESTINATION "include/libcpuid"
  PUBLIC_HEADER DESTINATION "include/libcpuid")

install(
  EXPORT "${TARGETS_EXPORT_NAME}"
  NAMESPACE "${namespace}"
  DESTINATION "${config_install_dir}")

install(FILES "${project_config}" "${version_config}" DESTINATION "${config_install_dir}")

add_custom_target(
  consistency
  COMMAND "./check-consistency.py" "./"
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/
  COMMENT "Check consistency"
  VERBATIM)

=== drivers/arm/CMakeLists.txt ===
# Options
option(LIBCPUID_DRIVER_DEBUG "Debug kernel driver" OFF)

if(LIBCPUID_DRIVER_DEBUG)
  add_definitions(-DLIBCPUID_DRIVER_DEBUG)
endif(LIBCPUID_DRIVER_DEBUG)

if("${CMAKE_SYSTEM_NAME}" STREQUAL "FreeBSD")
  add_subdirectory(freebsd)
elseif("${CMAKE_SYSTEM_NAME}" STREQUAL "Linux")
  add_subdirectory(linux)
endif()

=== python/docs/requirements.txt ===
sphinx-rtd-theme

=== drivers/arm/freebsd/CMakeLists.txt ===
set(DRIVER_NAME "cpuid")
set(DRIVER_SOURCE "${DRIVER_NAME}.c")
set(DRIVER_OBJECT "${DRIVER_NAME}.o")
set(DRIVER_MODULE "${DRIVER_NAME}.ko")

configure_file("${DRIVER_SOURCE}" "${CMAKE_CURRENT_BINARY_DIR}/${DRIVER_SOURCE}" COPYONLY)
configure_file(Makefile.in "${CMAKE_CURRENT_BINARY_DIR}/Makefile_kmod")

add_custom_command(OUTPUT "${DRIVER_MODULE}"
  COMMAND make -f Makefile_kmod
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  DEPENDS "${DRIVER_SOURCE}"
  COMMENT "Building CPUID kernel module for ARM..."
  VERBATIM
)

add_custom_target(driver-arm-cpuid ALL DEPENDS "${DRIVER_MODULE}")

=== drivers/arm/linux/CMakeLists.txt ===
# Options
option(LIBCPUID_DRIVER_ARM_LINUX_DKMS "Use DKMS for CPUID kernel module for ARM" ON)

set(DRIVER_NAME "cpuid")

if(LIBCPUID_DRIVER_ARM_LINUX_DKMS)
  message(STATUS "Deploying DKMS configuration for CPUID kernel module...")
  set(LIBCPUID_SRC_DIR "/usr/src/${CMAKE_PROJECT_NAME}-${PROJECT_VERSION}")

  configure_file(dkms.conf.in "${CMAKE_CURRENT_BINARY_DIR}/dkms.conf")
  configure_file(Makefile.in  "${CMAKE_CURRENT_BINARY_DIR}/Makefile_dkms")
  install(FILES
    cpuid.c
    "${CMAKE_SOURCE_DIR}/libcpuid/libcpuid_arm_driver.h"
    "${CMAKE_CURRENT_BINARY_DIR}/dkms.conf"
    DESTINATION "${LIBCPUID_SRC_DIR}/"
  )
  install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/Makefile_dkms"
    DESTINATION "${LIBCPUID_SRC_DIR}"
    RENAME "Makefile"
  )
else(LIBCPUID_DRIVER_ARM_LINUX_DKMS)
  find_package(LinuxKernelHeaders REQUIRED)

  set(DRIVER_SOURCE "${DRIVER_NAME}.c")
  set(DRIVER_OBJECT "${DRIVER_NAME}.o")
  set(DRIVER_MODULE "${DRIVER_NAME}.ko")
  set(KBUILD_CMD "make" EXTRA_CFLAGS="-I${CMAKE_SOURCE_DIR}/libcpuid" -C "${KERNELHEADERS_DIR}" "src=${CMAKE_CURRENT_SOURCE_DIR}" "M=${CMAKE_CURRENT_BINARY_DIR}")

  configure_file(Makefile.in "${CMAKE_CURRENT_SOURCE_DIR}/Makefile")
  add_custom_command(OUTPUT "${DRIVER_MODULE}"
    COMMAND ${KBUILD_CMD} modules
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    DEPENDS "${DRIVER_SOURCE}"
    COMMENT "Building CPUID kernel module for ARM..."
    VERBATIM
  )

  add_custom_target(driver-arm-cpuid ALL DEPENDS "${DRIVER_MODULE}")
endif(LIBCPUID_DRIVER_ARM_LINUX_DKMS)

=== debian/changelog ===
libcpuid (0.8.1+repack1-0.1) unstable; urgency=medium

  * NMU
  * rules-requires-root now defaults to no
  * New upstream release
  * Forward port soname patch

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 22 Aug 2025 13:31:34 +0100

=== debian/control ===
Source: libcpuid
Section: libs
Priority: optional
Maintainer: Martin Wimpress <code@wimpress.io>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: debhelper-compat (= 13),
               doxygen,
Standards-Version: 4.7.2
Homepage: https://github.com/anrieff/libcpuid
Vcs-Git: https://salsa.debian.org/debian/libcpuid.git
Vcs-Browser: https://salsa.debian.org/debian/libcpuid

Package: libcpuid18
Architecture: any-linux-amd64 any-linux-i386 any-linux-arm any-linux-armeb any-linux-arm64
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
Description: C library for x86/ARM CPU detection and feature extraction (shared lib)
 libcpuid is a small C library for x86/ARM CPU detection and feature
 extraction. Using it, you can:
 .
    - get the processor vendor, model, brand string, code name,
    - get information about CPU features such as: number of cores or logical
      CPUs, cache sizes, CPU clock,
    - check if the processor implements a specific instruction set such as
      the SSE2, 3DNow!,
    - execute the CPUID and RDTSC instructions (portably!)
 .
 This package ships the libcpuid shared library.

Package: libcpuid-dev
Architecture: any-linux-amd64 any-linux-i386 any-linux-arm any-linux-armeb any-linux-arm64
Multi-Arch: same
Depends: libcpuid18 (= ${binary:Version}),
         ${misc:Depends},
Section: libdevel
Description: C library for x86/ARM CPU detection and feature extraction (headers)
 libcpuid is a small C library for x86/ARM CPU detection and feature
 extraction. Using it, you can:
 .
    - get the processor vendor, model, brand string, code name,
    - get information about CPU features such as: number of cores or logical
      CPUs, cache sizes, CPU clock,
    - check if the processor implements a specific instruction set such as
      the SSE2, 3DNow!,
    - execute the CPUID and RDTSC instructions (portably!)
 .
 This package ships the libcpuid development headers.

Package: cpuidtool
Architecture: any-linux-amd64 any-linux-i386 any-linux-arm any-linux-armeb any-linux-arm64
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends},
Section: misc
Description: C library for x86/ARM CPU detection and feature extraction (tool)
 libcpuid is a small C library for x86/ARM CPU detection and feature
 extraction. Using it, you can:
 .
    - get the processor vendor, model, brand string, code name,
    - get information about CPU features such as: number of cores or logical
      CPUs, cache sizes, CPU clock,
    - check if the processor implements a specific instruction set such as
      the SSE2, 3DNow!,
    - execute the CPUID and RDTSC instructions (portably!)
 .
 This package ships the cpuidtool.

=== debian/watch ===
version=4
opts=repacksuffix=+repack1,dversionmangle=s/\+repack1// \
https://github.com/anrieff/@PACKAGE@/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@
